=== debian/changelog ===
qemu (1:5.1+dfsg-4) unstable; urgency=high

  * mention closing of CVE-2020-16092 by 5.1
  * usb-fix-setup_len-init-CVE-2020-14364.patch
    Closes: #968947, CVE-2020-14364
    (OOB r/w access in USB emulation)

 -- Michael Tokarev <mjt@tls.msk.ru>  Wed, 02 Sep 2020 16:14:52 +0300

qemu (1:5.1+dfsg-3) unstable; urgency=medium

  * fix one more issue in last upload. This is what happens when
    you do "obvious" stuff in a hurry without proper testing..

 -- Michael Tokarev <mjt@tls.msk.ru>  Mon, 17 Aug 2020 22:19:55 +0300

qemu (1:5.1+dfsg-2) unstable; urgency=medium

  * fix brown-paper bag bug in last upload 

 -- Michael Tokarev <mjt@tls.msk.ru>  Mon, 17 Aug 2020 20:58:52 +0300

qemu (1:5.1+dfsg-1) unstable; urgency=medium

  * hw-display-qxl.so depends on spice so install it
    only if it is built just like ui-spice-app
  * note #931046 for libfdt

 -- Michael Tokarev <mjt@tls.msk.ru>  Mon, 17 Aug 2020 18:57:14 +0300

qemu (1:5.1+dfsg-0exp1) experimental; urgency=medium

  * new upstream release 5.1.0. Make source DFSG-clean again
    Closes: #968088
    Closes: CVE-2020-16092 (net_tx_pkt_add_raw_fragment in e1000e & vmxnet3)
  * remove all patches which are applied upstream
  * do not install non-existing doc/qemu/*-ref.*
  * qemu-pr-helper is now in /usr/lib/qemu not /usr/bin
  * virtfs-proxy-helper is in /usr/lib/qemu now, not /usr/bin
  * new architecture: qemu-system-avr
  * refresh d/get-orig-source.sh
  * d/get-orig-source.sh: report already removed files in dfsg-clean
  * install common modules in qemu-system-common
  * lintian tag renamed: shared-lib-without-dependency-information to
    shared-library-lacks-prerequisites

 -- Michael Tokarev <mjt@tls.msk.ru>  Wed, 12 Aug 2020 19:09:24 +0300

qemu (1:5.0-14) unstable; urgency=high

  * this is a bugfix release before breaking toys with the new upstream
  * riscv-allow-64-bit-access-to-SiFive-CLINT.patch
    (another fix for revert-memory-accept-..-CVE-2020-13754)
  * install /usr/lib/*/qemu/ui-curses.so in qemu-system-common
    Closes: #966517

 -- Michael Tokarev <mjt@tls.msk.ru>  Fri, 31 Jul 2020 11:45:25 +0300

qemu (1:5.0-13) unstable; urgency=medium

  * seabios-hppa-fno-ipa-sra.patch
    fix ftbfs with gcc-10

 -- Michael Tokarev <mjt@tls.msk.ru>  Wed, 22 Jul 2020 22:16:41 +0300

qemu (1:5.0-12) unstable; urgency=medium

  * acpi-accept-byte-and-word-access-to-core-ACPI-registers.patch
    this replace cpi-allow-accessing-acpi-cnt-register-by-byte.patch
    and acpi-tmr-allow-2-byte-reads.patch, a more complete fix
  * xhci-fix-valid.max_access_size-to-access-address-registers.patch
    fix one more incarnation of the breakage after the CVE-2020-13754 fix
  * do not install outdated (0.12 and before) Changelog (Closes: #965381)
  * xgmac-fix-buffer-overflow-in-xgmac_enet_send-CVE-2020-15863.patch
    ARM-only XGMAC NIC, possible buffer overflow during packet transmission
    Closes: CVE-2020-15863
  * sm501 OOB read/write due to integer overflow in sm501_2d_operation()
    List of patches:
     sm501-convert-printf-abort-to-qemu_log_mask.patch
     sm501-shorten-long-variable-names-in-sm501_2d_operation.patch
     sm501-use-BIT-macro-to-shorten-constant.patch
     sm501-clean-up-local-variables-in-sm501_2d_operation.patch
     sm501-replace-hand-written-implementation-with-pixman-CVE-2020-12829.patch
    Closes: #961451, CVE-2020-12829

 -- Michael Tokarev <mjt@tls.msk.ru>  Wed, 22 Jul 2020 19:42:29 +0300

qemu (1:5.0-11) unstable; urgency=high

  * d/control-in: only enable opengl (libdrm&Co) on linux
  * d/control-in: spice: drop versioned deps (even jessie version is enough),
    drop libspice-protocol-dev (automatically pulled by libspice-server-dev),
    and build on more architectures
  * change from debhelper versioned dependency to debhelper-compat (=12)
  * acpi-allow-accessing-acpi-cnt-register-by-byte.patch' (Closes: #964793)
    This is another incarnation of the recent bugfix which actually enabled
    memory access constraints, like #964247
    Urgency = high due to this issue.

 -- Michael Tokarev <mjt@tls.msk.ru>  Mon, 20 Jul 2020 18:41:17 +0300

qemu (1:5.0-10) unstable; urgency=medium

  * fix the wrong $(if) construct for s390x kvm link (FTBFS on s390x)
  * use the same $(if) construct to simplify #ifdeffery

 -- Michael Tokarev <mjt@tls.msk.ru>  Sat, 18 Jul 2020 10:02:41 +0300

qemu (1:5.0-9) unstable; urgency=medium

  * move kvm executable/script from qemu-kvm to qemu-system-foo,
    make it multi-arch, and remove qemu-kvm package
  * remove libcacard leftovers from d/.gitignore
  * linux-user-refactor-ipc-syscall-and-support-of-semtimedop.patch
    (Closes: #965109)
  * linux-user-add-netlink-RTM_SETLINK-command.patch (Closes: #964289)
  * libudev is linux-specific, do not build-depend on it
    on kfreebsd and others
  * install virtiofsd in d/rules (!sparc64) instead of
    d/qemu-system-common.install (fixes FTBFS on sparc64)
  * confirm -static-pie not working today still
  * d/control: since qemu-system-data now contains module(s),
    it can't be multi-arch. Ditto for qemu-block-extra.
  * qemu-system-foo: depend on exact version of qemu-system-data,
    due to the latter having modules
  * build all modules since there are modules anyway,
    no need to hack them in d/rules
  * fix spelling in a patch name/subject inlast upload
  * d/rules: do not use dh_install and dh_movefiles for individual
    pkgs, open-code mkdir+cp/mv, b/c dh_install acts on all files
    listed in d/foo.install too, in addition to given on command-line
  * remove trailing whitespace from d/changelog

 -- Michael Tokarev <mjt@tls.msk.ru>  Sat, 18 Jul 2020 08:29:38 +0300

qemu (1:5.0-8) unstable; urgency=medium

  * d/control: rdma is linux-only, do not enable it on kfreebsd & hurd
  * add comment about virtiofsd conditional to d/qemu-system-common.install
    Now qemu FTBFS on sparc64 since virtiofsd is not built due to missing
    seccomp onn that platform, we should either make virtiofsd conditional

